#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <glib/gprintf.h>
#include "math.h"
#include <stdlib.h>
#include "callbacks.h"
#include "interface.h"
#include "support.h"

#define DEBUG 1

static GList *pixmaps_directories = NULL;

static gchar*
find_pixmap_file                       (const gchar     *filename)
{
  GList *elem;

  /* We step through each of the pixmaps directory to find it. */
  elem = pixmaps_directories;
  while (elem)
    {
      gchar *pathname = g_strdup_printf ("%s%s%s", (gchar*)elem->data,
                                         G_DIR_SEPARATOR_S, filename);
      if (g_file_test (pathname, G_FILE_TEST_EXISTS))
        return pathname;
      g_free (pathname);
      elem = elem->next;
    }
  return NULL;
}


void preparer_un_nouveau_calcul(gint *max, gint *a, gint *b, gint *c, const gchar * operateur)
{ gint tmp;
   srand(time(NULL));
   *a = rand() % (*max);
   *b = rand() % (*max);
	if (g_str_equal(operateur,"+"))
		*c = (*a)+(*b);	
	if (g_str_equal(operateur,"-"))	
		{
		if ((*a) < (*b)) //inverser a et b
			{
			tmp = *b;
			*b=*a;
			*a = tmp;
			}
		*c = (*a)-(*b); //a>b
		}
	if (g_str_equal(operateur,"x"))	
		*c = (*a)*(*b);
	if (g_str_equal(operateur,"/"))	
		{
#ifdef DEBUG
g_printf("a = %d\n",*a);
g_printf("b = %d\n",*b);
#endif
		while(((*b)==0)||((*a)<(*b))||((*a)%(*b)!=0))
			{
#ifdef DEBUG
g_printf("b a = %d\n",*a);
g_printf("b b = %d\n",*b);
#endif
			*a = rand() % (*max);
   			*b = rand() % (*max);
#ifdef DEBUG
g_printf("bb a = %d\n",*a);
g_printf("bb b = %d\n",*b);
#endif
				
			}			
	   	*c = (*a)/(*b);	//faire attention division entière
		}
}

void
on_quitter1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	//quit le programme
gtk_main_quit();
}


void
on____propos1_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
	// crée et affiche la fenêtre a propos
GtkWidget *	apropos = create_window2();
	gtk_widget_show (apropos);
}


void
on_button2_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
//démarrer test
	
//On commence par récupérer toutes les valeurs de l'interface
// type d'opération
/* Recuperation de la liste des boutons */
  const gchar *type_operation="";
  const gchar *operateur="";		
  GSList *pList = gtk_radio_button_get_group(GTK_RADIO_BUTTON(lookup_widget (GTK_WIDGET(button), "radiobutton_add")));	
	/* Parcours de la liste */
    while(pList)
    {
        /* Le bouton est il selectionne */
        if(gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(pList->data)))
        {
            /* OUI -> on copie le label du bouton */
            type_operation = gtk_button_get_label(GTK_BUTTON(pList->data));
            /* On met la liste a NULL pour sortir de la boucle */
            pList = NULL;
        }
        else
        {
            /* NON -> on passe au bouton suivant */
            pList = g_slist_next(pList);
        }
    }
	//g_printf("type opération %s\n", type_operation);
	if (g_str_equal(type_operation,"Addition"))
		operateur="+";	
	if (g_str_equal(type_operation,"Soustraction"))	
		operateur="-";	
	if (g_str_equal(type_operation,"Multiplication"))	
		operateur="x";	
	if (g_str_equal(type_operation,"Division"))	
		operateur="/";	

	// Récupération des entiers
	gint entier_max=0;
	gint nb_test=10;
	entier_max = gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(lookup_widget (GTK_WIDGET(button), "spinbutton1")));
	nb_test = gtk_spin_button_get_value_as_int( GTK_SPIN_BUTTON(lookup_widget (GTK_WIDGET(button), "spinbutton2")));
	
	//g_printf("type opération %d\n", entier_max);
	//g_printf("type opération %d\n", nb_test);
	
	//Génération et stockage des données
	gint a,b,c,nb_bon,nb_faux,score;
	nb_bon = 0;
	nb_faux = 0;
	score=0;
	preparer_un_nouveau_calcul(&entier_max,&a, &b, &c,operateur);
	g_object_set_data(G_OBJECT(button), "var_a", (gpointer) (a));
  	g_object_set_data(G_OBJECT(button), "var_b", (gpointer) (b));
  	g_object_set_data(G_OBJECT(button), "var_c", (gpointer) (c));
	g_object_set_data(G_OBJECT(button), "nb_bon", (gpointer) (nb_bon));	
	g_object_set_data(G_OBJECT(button), "nb_faux", (gpointer) (nb_faux));
	g_object_set_data(G_OBJECT(button), "score", (gpointer) (score));
  	g_object_set_data(G_OBJECT(button), "max", (gpointer) (entier_max));
	g_object_set_data(G_OBJECT(button), "nb_test", (gpointer) (nb_test));	
  	g_object_set_data(G_OBJECT(button), "oper", (gpointer) operateur);
	
	GtkWidget *label = lookup_widget (GTK_WIDGET(button), "label4"); 
	gtk_label_set_text(GTK_LABEL(label),
                    g_strdup_printf ("Combien font %d %s %d =", a,operateur, b) );
	GtkWidget *bouton_valider =  lookup_widget (GTK_WIDGET(button), "button1");
	gtk_widget_set_sensitive (bouton_valider, TRUE);
	GtkWidget *reponse =  lookup_widget (GTK_WIDGET(button), "entry1");
    gtk_widget_set_sensitive (reponse, TRUE);
	GtkWidget *bouton2 =  lookup_widget (GTK_WIDGET(button), "button4");
    gtk_widget_set_sensitive (bouton2, TRUE);
	gtk_widget_set_sensitive (GTK_WIDGET(button), FALSE);	
	
GtkWidget *entry_bon = lookup_widget (GTK_WIDGET(button), "entry2");   	  
GtkWidget *entry_faux = lookup_widget (GTK_WIDGET(button), "entry3");   	  
GtkWidget *entry_score = lookup_widget (GTK_WIDGET(button), "entry4");   	  	  
gtk_entry_set_text(GTK_ENTRY(entry_bon),g_strdup_printf (" "));	 
gtk_entry_set_text(GTK_ENTRY(entry_faux),g_strdup_printf (" "));	 	  
gtk_entry_set_text(GTK_ENTRY(entry_score),g_strdup_printf (" "));	 	  	  
  
}


void
on_button1_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	//valider réponse
const gchar *result_recupere;
gint resultat;
GtkWidget *entry_resultat = lookup_widget (GTK_WIDGET(button), "entry1");   
result_recupere = gtk_entry_get_text(GTK_ENTRY(entry_resultat));
resultat=atoi(result_recupere);
GtkWidget *label_info = lookup_widget (GTK_WIDGET(button), "label5"); 
GtkWidget *label_info2 = lookup_widget (GTK_WIDGET(button), "label14"); 
GtkWidget * image_info = lookup_widget (GTK_WIDGET(button), "image1");    
GtkWidget *bouton_demarrer = lookup_widget (GTK_WIDGET(button), "button2");


gint b= (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "var_b");
gint a= (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "var_a");
gint c= (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "var_c");		
gint nb_bon = (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "nb_bon");
gint nb_faux = (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "nb_faux");
gint score = (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "score");		
gint entier_max = (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "max");
gint nb_test = (gint) g_object_get_data(G_OBJECT(bouton_demarrer), "nb_test");	
gchar *operateur = 	(gchar *) g_object_get_data(G_OBJECT(bouton_demarrer), "oper");		

pixmaps_directories = g_list_prepend (pixmaps_directories, g_strdup ("/home/yann/Projects/operations/pixmaps"));
	//mettre le directory d'install à la place
gchar *pathname;

#ifdef DEBUG
g_printf("a = %d\n",a);
g_printf("b = %d\n",b);
g_printf("c = %d\n",c);
g_printf("max = %d\n",entier_max);
g_printf("nb test = %d\n",nb_test);
g_printf("operateur = %s\n",operateur);
#endif


if(resultat==(c))
      {
	  nb_bon++;
      gtk_label_set_text(GTK_LABEL(label_info),g_strdup_printf ("Bonne Réponse ! "));
gtk_label_set_text(GTK_LABEL(label_info2),g_strdup_printf ("Résultat  %d %s %d = %d", a, operateur, b, c));
		  pathname = find_pixmap_file ("emblem-cool.svg");
	  //g_printf("%s\n",pathname);
	  gtk_image_set_from_file (GTK_IMAGE(image_info), pathname); 
      }
 else {
	  nb_faux++;
      gtk_label_set_text(GTK_LABEL(label_info),g_strdup_printf ("Mauvaise Réponse ! "));
	  gtk_label_set_text(GTK_LABEL(label_info2),g_strdup_printf ("Résultat  %d %s %d = %d", a, operateur, b, c));	 
	  pathname = find_pixmap_file ("emblem-ohno.svg");
	  //g_printf("%s\n",pathname);
	  gtk_image_set_from_file (GTK_IMAGE(image_info), pathname); 
      }
score=(gint)(((((double)nb_bon)/((double)(nb_bon+nb_faux))))*100.0);
	  
GtkWidget *entry_bon = lookup_widget (GTK_WIDGET(button), "entry2");   	  
GtkWidget *entry_faux = lookup_widget (GTK_WIDGET(button), "entry3");   	  
GtkWidget *entry_score = lookup_widget (GTK_WIDGET(button), "entry4");   	  	  
gtk_entry_set_text(GTK_ENTRY(entry_bon),g_strdup_printf ("%d", nb_bon));	 
gtk_entry_set_text(GTK_ENTRY(entry_faux),g_strdup_printf ("%d", nb_faux));	 	  
gtk_entry_set_text(GTK_ENTRY(entry_score),g_strdup_printf ("%d", score));	 	  	  
if (nb_test!=-1)	  
	nb_test--;
if ((nb_test!=0)||(nb_test==-1))
	{
	//on refait un calcul
	preparer_un_nouveau_calcul(&entier_max,&a, &b, &c,operateur);
#ifdef DEBUG
g_printf("a = %d\n",a);
g_printf("b = %d\n",b);
g_printf("c = %d\n",c);
g_printf("max = %d\n",entier_max);
g_printf("nb test = %d\n",nb_test);
g_printf("operateur = %s\n",operateur);
#endif
	g_object_set_data(G_OBJECT(bouton_demarrer), "var_a", (gpointer)(a));
  	g_object_set_data(G_OBJECT(bouton_demarrer), "var_b", (gpointer)(b));
  	g_object_set_data(G_OBJECT(bouton_demarrer), "var_c", (gpointer)(c));
	g_object_set_data(G_OBJECT(bouton_demarrer), "nb_bon", (gpointer)(nb_bon));
  	g_object_set_data(G_OBJECT(bouton_demarrer), "nb_faux", (gpointer)(nb_faux));
  	g_object_set_data(G_OBJECT(bouton_demarrer), "score", (gpointer)(score));
	g_object_set_data(G_OBJECT(bouton_demarrer), "max", (gpointer)(entier_max));
	g_object_set_data(G_OBJECT(bouton_demarrer), "nb_test", (gpointer)(nb_test));		
  	g_object_set_data(G_OBJECT(bouton_demarrer), "oper", (gpointer)operateur);
	GtkWidget *label = lookup_widget (GTK_WIDGET(button), "label4"); 
	gtk_label_set_text(GTK_LABEL(label),
                    g_strdup_printf ("Combien font %d %s %d =", a,operateur, b) );		
	gtk_entry_set_text(GTK_ENTRY(entry_resultat),"");
	}
else
	{
	//on termine (activation de demarrer test ...
gtk_entry_set_text(GTK_ENTRY(entry_resultat),"");		
		GtkWidget *bouton_demarrer =  lookup_widget (GTK_WIDGET(button), "button2");
  gtk_widget_set_sensitive (bouton_demarrer, TRUE);					
		GtkWidget *bouton_valider =  lookup_widget (GTK_WIDGET(button), "button1");
		gtk_widget_set_sensitive (bouton_valider, FALSE);
	GtkWidget *reponse =  lookup_widget (GTK_WIDGET(button), "entry1");
    gtk_widget_set_sensitive (reponse, FALSE);		
  GtkWidget *bouton2 =  lookup_widget (GTK_WIDGET(button), "button4");
  gtk_widget_set_sensitive (bouton2, FALSE);
		
	}	
	  
//pathname = find_pixmap_file ("emblem-cool.svg");
//	g_printf("%s\n",pathname);
//gtk_image_set_from_file (GTK_IMAGE(image_info), pathname); //"/home/yann/Projects/operations/pixmaps/emblem-cool.svg"); 
	g_free (pathname);
}

void
on_button3_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	//ferme le fenêtre a propos
GtkWidget *apropos = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "window2");
	gtk_widget_destroy(apropos);
}

void
on_entry1_activate                     (GtkEntry        *entry,
                                        gpointer         user_data)
{
on_button1_released ((GtkButton *) entry, user_data);
}

void
on_window1_destroy_event               (GtkObject       *object,
                                        gpointer         user_data)
{
gtk_main_quit();
}

void
on_button2_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *statusbar = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "statusbar1");
    guint iContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "AjouterMsg");
	 gtk_statusbar_push (GTK_STATUSBAR (statusbar), GPOINTER_TO_INT(iContextId1), "Cliquez ici pour démarrer le test");
}


void
on_button2_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *statusbar = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "statusbar1");
    guint iContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "AjouterMsg");
	gtk_statusbar_pop (GTK_STATUSBAR (statusbar), GPOINTER_TO_INT(iContextId1));
}


void
on_button1_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *statusbar = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "statusbar1");
    guint iContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "AjouterMsg");
	 gtk_statusbar_push (GTK_STATUSBAR (statusbar), GPOINTER_TO_INT(iContextId1), "Cliquez ici pour valider votre réponse, ou taper ENTER");
}


void
on_button1_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *statusbar = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "statusbar1");
    guint iContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "AjouterMsg");
	gtk_statusbar_pop (GTK_STATUSBAR (statusbar), GPOINTER_TO_INT(iContextId1));
}

void
on_button4_released                    (GtkButton       *button,
                                        gpointer         user_data)
{
	gchar *pathname;
	GtkWidget * image_info = lookup_widget (GTK_WIDGET(button), "image1");    
GtkWidget *entry_resultat = lookup_widget (GTK_WIDGET(button), "entry1");   
	gtk_entry_set_text(GTK_ENTRY(entry_resultat),"");		
		GtkWidget *bouton_demarrer =  lookup_widget (GTK_WIDGET(button), "button2");
  gtk_widget_set_sensitive (bouton_demarrer, TRUE);					
		GtkWidget *bouton_valider =  lookup_widget (GTK_WIDGET(button), "button1");
		gtk_widget_set_sensitive (bouton_valider, FALSE);
	GtkWidget *reponse =  lookup_widget (GTK_WIDGET(button), "entry1");
    gtk_widget_set_sensitive (reponse, FALSE);		
  GtkWidget *bouton2 =  lookup_widget (GTK_WIDGET(button), "button4");
  gtk_widget_set_sensitive (bouton2, FALSE);
GtkWidget *label_info = lookup_widget (GTK_WIDGET(button), "label5"); 
GtkWidget *label_info2 = lookup_widget (GTK_WIDGET(button), "label14"); 
      gtk_label_set_text(GTK_LABEL(label_info),g_strdup_printf ("Bonne Chance"));
gtk_label_set_text(GTK_LABEL(label_info2),g_strdup_printf (" "));

	
	pixmaps_directories = g_list_prepend (pixmaps_directories, g_strdup ("/home/yann/Projects/operations/pixmaps"));	
  pathname = find_pixmap_file ("emblem-fun.svg");
	  //g_printf("%s\n",pathname);
	  gtk_image_set_from_file (GTK_IMAGE(image_info), pathname); 
g_free(pathname);

}


void
on_button4_enter                       (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *statusbar = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "statusbar1");
    guint iContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "AjouterMsg");
	 gtk_statusbar_push (GTK_STATUSBAR (statusbar), GPOINTER_TO_INT(iContextId1), "Cliquez ici pour stoppper le test");
}


void
on_button4_leave                       (GtkButton       *button,
                                        gpointer         user_data)
{
GtkWidget *statusbar = (GtkWidget *) lookup_widget (GTK_WIDGET (button), "statusbar1");
    guint iContextId1 = gtk_statusbar_get_context_id(GTK_STATUSBAR(statusbar), "AjouterMsg");
	gtk_statusbar_pop (GTK_STATUSBAR (statusbar), GPOINTER_TO_INT(iContextId1));
}
